import { LRParser } from '@lezer/lr';
import { NodeProp } from '@lezer/common';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';
import { completeFromList } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "!jOVQPOOO_QPO'#C^OOQO'#C^'#C^QOQPOOOmQPO,58|OxQPO'#ChO!QQPO1G.hOVQPO'#CdO!VQPO,59SOOQO7+$S7+$SOOQO,59O,59OOOQO-E6b-E6b",
  stateData: "!_~OZOS~ORQOSPO~OVSOXQXTQX]QX~ORQOSPOT[P~O]VOT[X~OTXO~O]VOT[a~O",
  goto: "u]PP^PPPgPlPPPrQROQTSRYVVQOSVQWTRZWRUS",
  nodeNames: "⚠ Program Expr String Identifier ) Application (",
  maxTerm: 13,
  nodeProps: [
    [NodeProp.group, 2,"Expression"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "#o~R]XYzYZz]^zpqzrs!]xy!zyz#P|}#U}!O#Z!Q![#Z!c!}#Z#R#S#Z#T#o#Z~!PSZ~XYzYZz]^zpqz~!`TOr!]rs!os#O!]#O#P!t#P~!]~!tOR~~!wPO~!]~#POV~~#UOT~~#ZO]~~#`TS~}!O#Z!Q![#Z!c!}#Z#R#S#Z#T#o#Z",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const BSLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        closeBrackets: { brackets: ['('] }
    }
});
const bslangCompletion = BSLanguage.data.of({
    autocomplete: completeFromList([
        { label: "avg", type: "function" },
        { label: "sum", type: "function" },
        { label: "zSpread", type: "function" },
        { label: "CB.BTC.USD", type: "variable" },
        { label: "CB.DOGE.RUB", type: "variable" },
    ])
});
function BSLANG() {
    return new LanguageSupport(BSLanguage, [bslangCompletion]);
}

export { BSLANG, BSLanguage, bslangCompletion };
